#!/bin/bash
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
INSTALLDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )"/../.. && pwd )"
. /etc/os-release
OS=$ID


echo "    --  Applying rights"
if [ $OS = "centos" ]
then
    chown apache:apache -R "$INSTALLDIR/$PRODUCTNAME"
else
    chown www-data:www-data -R "$INSTALLDIR/$PRODUCTNAME"
fi

echo "    --  Creating cron file"
cat > /etc/cron.d/phonebookmanager <<-"EOF"
    0 0 * * * root rm -f /var/log/phonebookmanager_syncinternal.log
    */2 * * * * root php $INSTALLDIR/$PRODUCTNAME/scripts/SyncInternal.php >> /var/log/phonebookmanager_syncinternal.log 2>&1
    0 0 * * * root php $INSTALLDIR/$PRODUCTNAME/scripts/backupcontacts.php
EOF

echo "    --  Creating Ombutel app"
php $DIR/InstallAPIKeyOmbutel.php


echo "    --  Installing LDAP"
systemctl stop slapd
rm -rf /var/lib/ldap/*

mkdir -p /var/lib/ldap
cat > /var/lib/ldap/DB_CONFIG <<EOF
set_cachesize 0 268435456 1
set_lg_regionmax 262144
set_lg_bsize 2097152     
EOF

if [ $OS = "centos" ]
then
    rm -rf /etc/openldap/slapd.d/cn\=config*
    slapadd -n0 -F /etc/openldap/slapd.d -l $DIR/config_centos.ldif
    slapadd -n2 -F /etc/openldap/slapd.d -l $DIR/base.ldif
    chown -R ldap:ldap /etc/openldap/slapd.d
    chown -R ldap:ldap /var/lib/ldap
    systemctl restart httpd
else
    rm -rf /etc/ldap/slapd.d/cn\=config*
    slapadd -n0 -F /etc/ldap/slapd.d -l $DIR/config_debian.ldif
    slapadd -n1 -F /etc/ldap/slapd.d -l $DIR/base.ldif
    chown -R openldap:openldap /etc/ldap/slapd.d
    chown -R openldap:openldap /var/lib/ldap
    systemctl restart apache2
fi
systemctl start slapd
