<?php

/* 
 * Copyright (C) 2017 IPCONNECT, tous droits réservés
 *
 * 1068 Rue de la vieille poste
 * 34000 Montpellier
 * France
 * o.varenne@ipconnect.fr
 * 0033 (0)4 27 04 04 50
 */

require_once "OmbutelLink.php";
require_once '../classes/Annuaire.php';
require_once '../classes/Contact.php';

$backupdir = substr(__dir__, 0, strrpos(__dir__, "/")) . "/backup";
echo "Sauvegarde dans le dossier $backupdir" . PHP_EOL;

if (!file_exists($backupdir))
{
    mkdir($backupdir);
}


//Supprime du dossier de sauvegarde les fichiers qui ont plus de 30 jours.
foreach (glob($backupdir."/*") as $file) 
{
    if(time() - filectime($file) > 2592000)
    {
        echo "Suppression du fichier $file datant de plus de 30 jours".PHP_EOL;
        unlink($file);
    }
}

//créé un dossier temporaire
$dossiertemp = "/tmp/phonebookmanagerbackup_" . date("dmY");
if (file_exists("$dossiertemp"))
{
    array_map('unlink', glob("$dossiertemp/*"));
    rmdir("$dossiertemp");
}
mkdir("$dossiertemp");

$annu = Annuaire::GetAnnuaires();
foreach ($annu as $a) 
{
    echo "Sauvegarde des contacts de l'annuaire $a->nom" . PHP_EOL;
    $contacts = Contact::GetContacts($a->nom, "");
    $retour = "ID;Societe;Fonction;Nom;Prenom;Telephone;Mobile;Autre;Email" . PHP_EOL;
    for ($i=0; $i<count($contacts); $i++)
    {
        $id = $contacts[$i]->id;
        $societe = trim(mb_convert_encoding($contacts[$i]->societe, "UTF-8", "auto"));
        $fonction = trim(mb_convert_encoding($contacts[$i]->fonction, "UTF-8", "auto"));
        $nom = trim(mb_convert_encoding($contacts[$i]->nom, "UTF-8", "auto"));
        $prenom = trim(mb_convert_encoding($contacts[$i]->prenom, "UTF-8", "auto"));
        $telephone = trim(mb_convert_encoding($contacts[$i]->telephone, "UTF-8", "auto"));
        $autre = trim(mb_convert_encoding($contacts[$i]->autre, "UTF-8", "auto"));
        $mobile = trim(mb_convert_encoding($contacts[$i]->mobile, "UTF-8", "auto"));
        $email = trim(mb_convert_encoding($contacts[$i]->email, "UTF-8", "auto"));

        $retour .= "$id;$societe;$fonction;$nom;$prenom;$telephone;$autre;$mobile;$email" . PHP_EOL;
    }
    file_put_contents("$dossiertemp/$a->nom.csv", $retour);
}

$zip = new ZipArchive();
$filename = "phonebookmanager_backup_" . date("dmY") . ".zip";
$zip->open("$backupdir/$filename", ZipArchive::CREATE | ZipArchive::OVERWRITE);


$files = new RecursiveIteratorIterator
(
    new RecursiveDirectoryIterator($dossiertemp),
    RecursiveIteratorIterator::LEAVES_ONLY
);

foreach ($files as $name => $file)
{
    // Skip directories (they would be added automatically)
    if (!$file->isDir())
    {
        // Get real and relative path for current file
        $filePath = $file->getRealPath();
        $relativePath = substr($filePath, strlen($dossiertemp) + 1);

        // Add current file to archive
        $zip->addFile($filePath, $relativePath);
    }
}

// Zip archive will be created only after closing object
$zip->close();